# avltree
[![Stable Version](https://img.shields.io/pypi/v/avltree?color=blue)](https://pypi.org/project/avltree/)
[![Build Status](https://github.com/cfandrews/PythonAvlTree/actions/workflows/build.yml/badge.svg)](https://github.com/cfandrews/PythonAvlTree/actions)
[![Documentation Status](https://github.com/cfandrews/PythonAvlTree/actions/workflows/documentation.yml/badge.svg)](https://github.com/cfandrews/PythonAvlTree/actions)
[![Checked with mypy](https://www.mypy-lang.org/static/mypy_badge.svg)](https://mypy-lang.org/)
[![Linting: Ruff](https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/charliermarsh/ruff/main/assets/badge/v2.json)](https://github.com/astral-sh/ruff)

This package is a lightweight, pure-Python implementation of the AVL tree. AVL trees are simple self-balancing binary
search trees, giving them both amortized and worst-case time complexities of O[log(n)] for insertion, deletion, and
retrieval. More reference can be found on the [AVL tree Wikipedia page](https://en.wikipedia.org/wiki/AVL_tree).

[PyPI](https://pypi.org/project/avltree/)\
[Source](https://github.com/cfandrews/PythonAvlTree)\
[Documentation](https://cfandrews.github.io/PythonAvlTree/avltree.html)

## Installation
This package is available on PyPI and can be installed with pip:
```shell
pip install avltree
```
